
// simulates a running MBS
// status server

#include "typedefs.h"
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include "sys_def.h"
#include "sbs_def.h"
#include "s_daqst.h"
#include "f_stccomm.h"

main(argc,argv)
     int argc;
     char *argv[];
{
  INTS4      l_port_sts=6008;
  struct s_tcpcomm    s_tcp_sts;
  INTS4      l_tcp_stat_serv=0;
  INTS4 l_status,l_cmd;
  s_daqst *ps_daqst;

  // create and set up status block
  ps_daqst = (s_daqst *) malloc(sizeof(s_daqst));
  memset(ps_daqst,0,sizeof(s_daqst));
  f_ut_status_ini(ps_daqst);
  ps_daqst->l_block_size = 8192; // buffer size bytes
  ps_daqst->l_open_file  = 1;    // is file open?
  ps_daqst->l_file_cur   = 1;    // when auto file, current number
  sprintf(ps_daqst->c_file_name,"abc_%04d.lmd",ps_daqst->l_file_cur); // file name
  strcpy(ps_daqst->c_user,"MBSuser");
  strcpy(ps_daqst->c_exprun,"Run12");
  strcpy(ps_daqst->c_exper,"Experiment test");
  strcpy(ps_daqst->c_host,"r2f-2");
  strcpy(ps_daqst->c_remote,"lxg0500");
  strcpy(ps_daqst->c_display,"lxg0500");
  strcpy(ps_daqst->c_pathstr,"test/rio");
  strcpy(ps_daqst->c_devname,"disk");
  strcpy(ps_daqst->c_setup_name,"setup.usf");
  ps_daqst->bh_acqui_started = 1;
  ps_daqst->bh_acqui_running = 1;
  ps_daqst->bh_setup_loaded  = 1;
  // mark running tasks:
  ps_daqst->bh_running[SYS__dispatch]   = 1;
  ps_daqst->bh_running[SYS__msg_log]    = 1;
  ps_daqst->bh_running[SYS__util]       = 1;
  ps_daqst->bh_running[SYS__collector]  = 1;
  ps_daqst->bh_running[SYS__transport]  = 1;
  ps_daqst->bh_running[SYS__read_meb]   = 1;
  ps_daqst->bh_running[SYS__event_serv] = 1;
  strcpy(ps_daqst->c_pname[0],"Dispatcher");
  strcpy(ps_daqst->c_pname[1],"Message logger");
  strcpy(ps_daqst->c_pname[2],"Utility");
  strcpy(ps_daqst->c_pname[3],"Collector");
  strcpy(ps_daqst->c_pname[4],"Transport");
  strcpy(ps_daqst->c_pname[5],"Readout");
  strcpy(ps_daqst->c_pname[6],"Event server");
  ps_daqst->l_procs_run = 7; // 7 tasks
  l_status = f_stc_createserver (&l_port_sts, &s_tcp_sts);
  l_tcp_stat_serv=s_tcp_sts.sock_rw;

  // wait for client and send new data
  while (1)
    {
      l_status = f_stc_acceptclient (&s_tcp_sts, &l_tcp_stat_serv);
      l_status = f_stc_read (&l_cmd, 4, l_tcp_stat_serv, -1);

      ps_daqst->l_file_size          = 10;   // maximum file size [MB]
      ps_daqst->bl_n_kbyte_file     += 500;  // data written to file
      // simulate full file, increment file counter:
      if(ps_daqst->bl_n_kbyte_file > (ps_daqst->l_file_size*1000)) 
	{
          ps_daqst->l_file_cur          += 1;   // when auto file, current number
          sprintf(ps_daqst->c_file_name,"abc_%04d.lmd",ps_daqst->l_file_cur); // file name
          ps_daqst->bl_n_kbyte_file      = 0;  // new file empty
	}
      ps_daqst->bl_n_buffers        += 10;  // total number of buffers
      ps_daqst->bl_n_events         += 100; // total number of events
      ps_daqst->bl_n_bufstream      += 5;   // total numbers of streams
      ps_daqst->bl_n_evserv_events  += 50;  // events delivered by event server
      ps_daqst->bl_n_evserv_kbytes  += 10;  // data delivered by event server
      ps_daqst->bl_n_kbyte_tape     += 50;  // data written to tape
      ps_daqst->bl_n_strserv_bufs   += 20;  // buffers delivered by stream server
      ps_daqst->bl_n_strserv_kbytes +=      // data delivered by stream server 
                                    (ps_daqst->bl_n_strserv_bufs*ps_daqst->l_block_size)/1000;
      // send data
      l_status=f_ut_status(ps_daqst,l_tcp_stat_serv);
      if(l_tcp_stat_serv!=0) f_stc_discclient(l_tcp_stat_serv);
    }
}
